package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import java.util.List;

public class GetReferenceExample {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        try {
            persistTask(emf);
            persistEmployee(emf);
            allEmployeesQuery(emf);
        } finally {
            emf.close();
        }
    }

    private static void persistTask(EntityManagerFactory emf) {
        System.out.println("-- persisting Task --");
        Task task = new Task();
        task.setName("test task");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        em.persist(task);
        em.getTransaction().commit();
        em.close();
        System.out.println("Task persisted: " + task);
    }

    private static void persistEmployee(EntityManagerFactory emf) {
        System.out.println("-- persisting employee --");
        Employee employee = new Employee();
        employee.setName("Joe");
        EntityManager em = emf.createEntityManager();
        Task task = em.getReference(Task.class, 1);
        employee.setTask(task);
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        em.close();
        System.out.println("Employee persisted: " + employee);
    }

    private static void allEmployeesQuery(EntityManagerFactory emf) {
        System.out.println("-- select all employee query --");
        EntityManager em = emf.createEntityManager();
        Query query = em.createQuery("select t from Employee t");
        List<Employee> resultList = query.getResultList();
        for (Employee employee : resultList) {
            System.out.println(employee + " " + employee.getTask());
        }
    }
}